SystemOrganization addCategory: #'Math-Accuracy-ODE'!

Object subclass: #ODEAccuracy
	instanceVariableNames: 'dt function startState startTime endTime standard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Accuracy-ODE'!

!ODEAccuracy class methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 18:48'!
run
	| instance checkSelectors |
	instance := self new.
	checkSelectors := self selectors select: [ :each | each beginsWith: 'check' ].
	^ (checkSelectors collect: [ :selector |
		(selector copyFrom: 6 to: selector size) ->
		((instance perform: selector) - instance standard) abs ]) asDictionary! !

!ODEAccuracy class methodsFor: 'as yet unclassified' stamp: 'YuriyTymchuk 9/16/2013 14:22'!
runToXML
	| writer |
	writer := XMLWriter new.
	writer
		enablePrettyPrinting;
		xml.
	writer tag: 'accuracy' with: [ 
		self run keysAndValuesDo:  [ :key :value |
			writer tag: key with: value asString]].

	^ writer ! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:36'!
checkAB2
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:37'!
checkAB3
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:37'!
checkAB4
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:39'!
checkAM3
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:39'!
checkAM4
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:41'!
checkBDF2
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:41'!
checkBDF3
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:41'!
checkBDF4
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/16/2013 00:58'!
checkBeckwardEuler
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := ImplicitStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 18:45'!
checkEuler
	|  solver stepper system |
	system := ExplicitSystem block: function.
	stepper := ExplicitStepper onSystem:  system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 18:45'!
checkHeun
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/16/2013 00:59'!
checkImplicitMidpoint
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := ImplicitMidpointStepper onSystem: system.
	solver := (ImplicitMidpointSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 18:45'!
checkMidpoint
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 18:45'!
checkRungeKutta
	| solver stepper system |
	system := ExplicitSystem block: function.
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 20:40'!
checkTrapezoidAM2
	| solver stepper system |
	system := ImplicitSystem block: function.
      stepper := TrapezoidStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	^ solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/16/2013 00:48'!
initialize
	dt :=0.09.
	function :=  [:x :t | (t ** 4) * (t sin ** (2 * t cos)) * ( (2 * t negated) * (2 * t sin) * (t sin log) + t * (2 * t cos) * (t tan reciprocal) + 5)].
	startState := 0.
	startTime := 0.3 .
	endTime := Float halfPi ! !

!ODEAccuracy methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/16/2013 00:47'!
standard
	standard ifNil: [ 
		standard := [:t | (t ** 5) * (t sin ** (2*t cos))-0.000888511] value: endTime ].
	^ standard  ! !
